<?php
namespace App\Model;
use Illuminate\Database\Eloquent\Model;

class GetPackCount extends Model {

    private $packCountUrl;

    function __construct() {

        $this->packCountUrl = env('GET_PACK_COUNT_MIDDLEWARE_URL', true); 
    }

    /**
     * Get product pack count
     */
    public function getPackCount($request) {

        if (!empty($request)) {

            $url = $this->packCountUrl;
            $type = 'POST';
            $api_key = null;
            $api_passwd = null;

            return $this->executeCurl($url, $type, $request, $api_key, $api_passwd);
        } else {
            return null;
        }
    }

    /**
     * Get pack count CURL call
     */
    public function executeCurl($url, $type, $data, $api_key, $api_passwd) {

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            "Content-Type: application/json"
        ));
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false); // temporarily disable SSL verification
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); // temporarily disable SSL verification

        if ($type == "POST") {
            curl_setopt($ch, CURLOPT_POST, true);
            $json = json_encode($data);
            $payload = '"' . addslashes($json) . '"';
            curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);
        }

        if ($type == "PUT") {
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
            $json = json_encode($data);
            $payload = '"' . addslashes($json) . '"';
            curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);
        }

        $result = curl_exec($ch);

        if (curl_errno($ch)) {
            echo 'Request Error:' . curl_error($ch);
            return false;
        }

        //Log::info("curl result  => " . $result);
        return $result;
    }
}
